Summary: Experimental GNU Compiler System
Name: egcs
Version: 1.1.2pre2
Release: 1
Group: Development/Languages
Copyright: GPL
Url: http://egcs.cygnus.com/
Packager: Hao Li <hli@wag.caltech.edu>
Source: ftp://egcs.cygnus.com/pub/egcs/releases/%{name}-%{version}/%{name}-1.1.2-pre2.tar.gz
Buildroot: /var/tmp/%{name}-root

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.


%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: egcs = %{version}

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.


%package objc
Summary: Objective C support for gcc
Group: Development/Languages
Requires: egcs = %{version}

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.


%package g77
Summary: Fortran 77 support for gcc
Group: Development/Languages
Requires: egcs = %{version}

%description g77
This apckage adds support for compiling Fortran 77 programs with the GNU
compiler.


%package libstdc++
Summary: GNU c++ library
Group: Libraries

%description libstdc++
This is the GNU implementation of the standard C++ libraries, along with
additional GNU tools.  This package includes the shared libraries
necessary to run C++ applications.


%package libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: egcs-libstdc++ = %{version}

%description libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development.


%prep
%setup -q -n egcs-1.1.2-pre2


%build
rm -rf obj-i386-redhat-linux
mkdir  obj-i386-redhat-linux
cd     obj-i386-redhat-linux
../configure --prefix=/usr --enable-shared --enable-threads i386-redhat-linux
make MAKEINFO="makeinfo --no-split"  bootstrap-lean


%install
rm -rf $RPM_BUILD_ROOT
cd obj-i386-redhat-linux
make prefix=$RPM_BUILD_ROOT/usr MAKEINFO="makeinfo --no-split" install
strip $RPM_BUILD_ROOT/usr/bin/*
strip $RPM_BUILD_ROOT/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/\
{cc1,cc1obj,cc1plus,collect2,cpp,f771}
gzip -9 $RPM_BUILD_ROOT/usr/info/*

ln -sf i386-redhat-linux-gcc	$RPM_BUILD_ROOT/usr/bin/gcc
ln -sf gcc			$RPM_BUILD_ROOT/usr/bin/cc
ln -sf g++			$RPM_BUILD_ROOT/usr/bin/c++
ln -sf g77			$RPM_BUILD_ROOT/usr/bin/f77
ln -sf gcc.1			$RPM_BUILD_ROOT/usr/man/man1/cc.1
ln -sf g++.1			$RPM_BUILD_ROOT/usr/man/man1/c++.1
ln -sf g77.1			$RPM_BUILD_ROOT/usr/man/man1/f77.1

mkdir -p $RPM_BUILD_ROOT/lib
FULLVER=`$RPM_BUILD_ROOT/usr/bin/i386-redhat-linux-gcc --version`
ln -sf ../usr/lib/gcc-lib/i386-redhat-linux/$FULLVER/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf cccp.1		$RPM_BUILD_ROOT/usr/man/man1/cpp.1


%post
/sbin/install-info /usr/info/cpp.info.gz /usr/info/dir
/sbin/install-info /usr/info/gcc.info.gz /usr/info/dir

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete /usr/info/cpp.info.gz /usr/info/dir
    /sbin/install-info --delete /usr/info/gcc.info.gz /usr/info/dir
fi


%post g77
/sbin/install-info /usr/info/g77.info.gz /usr/info/dir

%preun g77
if [ $1 = 0 ]; then
    /sbin/install-info --delete /usr/info/g77.info.gz /usr/info/dir
fi


%post   libstdc++ -p /sbin/ldconfig
%postun libstdc++ -p /sbin/ldconfig


%files
%defattr(-,root,root)
%doc COPYING COPYING.LIB ChangeLog INSTALL MAINTAINERS README
%dir /usr/lib/gcc-lib
%dir /usr/lib/gcc-lib/i386-redhat-linux
%dir /usr/lib/gcc-lib/i386-redhat-linux/egcs-*
%dir /usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include
/lib/cpp
/usr/bin/cc
/usr/bin/gcc
/usr/bin/gcov
/usr/bin/i386-redhat-linux-gcc
/usr/bin/protoize
/usr/bin/unprotoize
/usr/i386-redhat-linux
/usr/info/cpp.info.gz
/usr/info/gcc.info.gz
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/SYSCALLS.c.X
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/cc1
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/collect2
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/cpp
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/crt*.o
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/libgcc.a
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/specs
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/README
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/float.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/iso646.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/limits.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/proto.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/stdarg.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/stdbool.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/stddef.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/syslimits.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/va-*.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/varargs.h
/usr/man/man1/cc.1
/usr/man/man1/cccp.1
/usr/man/man1/cpp.1
/usr/man/man1/gcc.1

%files c++
%defattr(-,root,root)
/usr/bin/c++
/usr/bin/c++filt
/usr/bin/g++
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/cc1plus
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/exception
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/new
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/new.h
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/typeinfo
/usr/man/man1/c++.1
/usr/man/man1/g++.1

%files objc
%defattr(-,root,root)
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/cc1obj
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/libobjc.a
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/objc

%files g77
%defattr(-,root,root)
/usr/bin/f77
/usr/bin/g77
/usr/info/g77.info.gz
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/f771
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/libg2c.a
/usr/lib/gcc-lib/i386-redhat-linux/egcs-*/include/g2c.h
/usr/man/man1/f77.1
/usr/man/man1/g77.1

%files libstdc++-devel
%defattr(-,root,root)
/usr/include/g++
/usr/lib/libstdc++.a
/usr/lib/libstdc++.so

%files libstdc++
%defattr(-,root,root)
/usr/lib/libstdc++.so.*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Mon Feb 27 1999 Hao Li <hli@wag.caltech.edu>
- Upgraded to 1.1.2pre2-1.

* Mon Feb 22 1999 Hao Li <hli@wag.caltech.edu>
- Upgraded to 1.1.2pre1-1. Changes include:
- Renamed libstdc++ and libstdc++-devel sub-packages to egcs so that we can
  start from release 1;
- Since %{version} cannot contain "-" we renamed %{version} from 1.1.2-pre1
  which is given by egcs author to 1.1.2pre1. When the "pre1" is gone the
  exception handling in %Source and %setup can be removed.

* Sun Feb  7 1999 Hao Li <hli@wag.caltech.edu>
- Upgraded to 1.1.1-2. Changes include:
- Included /usr/bin/c++filt since binutils-2.9.1.0.20 no longer includes it;
- Changed build host from i386-linux to i386-redhat-linux;
- Removed STDC_RELEASE so that libstdc++ shares the same release number
  with egcs. This may cause some version reversals but I know how to handle
  them.

* Mon Dec  7 1998 Hao Li <hli@wag.caltech.edu>
- After my clean-up this spec file works only on i386-linux.
- Compared with standard "make install", /usr/bin/c++filt and 
  /usr/lib/libiberty.a are the only two files left out since they conflict 
  with the ones from binutils-2.9.1.0.15-1.
- Several files under /usr/bin generated by "make install" are duplicated
  so I changed them from real file to symbolic links. These include:
  	gcc -> i386-linux-gcc 
  	c++ -> g++
  These two links under /usr/bin are added:
  	cc  -> gcc
	f77 -> g77
